/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.equivalencia;

import com.rjconsultores.ventaboletos.entidad.MotivocancelacionEquivalencia;
import com.rjconsultores.ventaboletos.service.MotivoCancelacionService;
import com.rjconsultores.ventaboletos.entidad.ComisionistaExterno;
import com.rjconsultores.ventaboletos.entidad.MotivoCancelacion;
import com.rjconsultores.ventaboletos.service.ComisionistaExternoService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderMotivocancelacionEquivalencia;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Rafius
 */
@Controller("busquedaMotivocancelacionEquivalenciaController")
@Scope("prototype")
public class BusquedaMotivocancelacionEquivalenciaController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<MotivocancelacionEquivalencia> plwMotivocancelacionEquivalencia;
    @Autowired
    private ComisionistaExternoService comisionistaExternoService;
    @Autowired
    private MotivoCancelacionService motivoCancelacionService;
    private MyListbox motivoCancelacionEquivalenciaList;
    private Paging pagingMotivocancelacionEquivalencia;
    private Combobox cmbComissionestaExterno;
    private Combobox cmbMotivoCancelacion;
    private Textbox txtEquivalencia;
    private List<ComisionistaExterno> lsComisionistaExterno;
    private List<MotivoCancelacion> lsMotivoCancelacion;

    public Combobox getCmbComissionestaExterno() {
        return cmbComissionestaExterno;
    }

    public void setCmbComissionestaExterno(Combobox cmbComissionestaExterno) {
        this.cmbComissionestaExterno = cmbComissionestaExterno;
    }

    public MyListbox getMotivocancelacionEquivalenciaList() {
        return motivoCancelacionEquivalenciaList;
    }

    public void setMotivocancelacionEquivalenciaList(MyListbox motivoCancelacionEquivalenciaList) {
        this.motivoCancelacionEquivalenciaList = motivoCancelacionEquivalenciaList;
    }

    public List<ComisionistaExterno> getLsComisionistaExterno() {
        return lsComisionistaExterno;
    }

    public void setLsComisionistaExterno(List<ComisionistaExterno> lsComisionistaExterno) {
        this.lsComisionistaExterno = lsComisionistaExterno;
    }

    public Paging getPagingMotivocancelacionEquivalencia() {
        return pagingMotivocancelacionEquivalencia;
    }

    public void setPagingMotivocancelacionEquivalencia(Paging pagingMotivocancelacionEquivalencia) {
        this.pagingMotivocancelacionEquivalencia = pagingMotivocancelacionEquivalencia;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verMotivocancelacionEquivalencia(new MotivocancelacionEquivalencia());
    }

    public ComisionistaExternoService getComisionistaExternoService() {
        return comisionistaExternoService;
    }

    public void setComisionistaExternoService(ComisionistaExternoService comisionistaExternoService) {
        this.comisionistaExternoService = comisionistaExternoService;
    }

    public List<MotivoCancelacion> getLsMotivoCancelacion() {
        return lsMotivoCancelacion;
    }

    public void setLsMotivoCancelacion(List<MotivoCancelacion> lsMotivoCancelacion) {
        this.lsMotivoCancelacion = lsMotivoCancelacion;
    }

    public MyListbox getMotivoCancelacionEquivalenciaList() {
        return motivoCancelacionEquivalenciaList;
    }

    public void setMotivoCancelacionEquivalenciaList(MyListbox motivoCancelacionEquivalenciaList) {
        this.motivoCancelacionEquivalenciaList = motivoCancelacionEquivalenciaList;
    }

    public MotivoCancelacionService getMotivoCancelacionService() {
        return motivoCancelacionService;
    }

    public void setMotivoCancelacionService(MotivoCancelacionService motivoCancelacionService) {
        this.motivoCancelacionService = motivoCancelacionService;
    }

    public PagedListWrapper<MotivocancelacionEquivalencia> getPlwMotivocancelacionEquivalencia() {
        return plwMotivocancelacionEquivalencia;
    }

    public void setPlwMotivocancelacionEquivalencia(PagedListWrapper<MotivocancelacionEquivalencia> plwMotivocancelacionEquivalencia) {
        this.plwMotivocancelacionEquivalencia = plwMotivocancelacionEquivalencia;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsComisionistaExterno = comisionistaExternoService.obtenerTodos();
        lsMotivoCancelacion = motivoCancelacionService.obtenerTodos();

        super.doAfterCompose(comp);

        motivoCancelacionEquivalenciaList.setItemRenderer(new RenderMotivocancelacionEquivalencia());
        motivoCancelacionEquivalenciaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                MotivocancelacionEquivalencia c = (MotivocancelacionEquivalencia) motivoCancelacionEquivalenciaList.getSelected();
                verMotivocancelacionEquivalencia(c);
            }
        });

        cmbMotivoCancelacion.focus();
        refreshLista();
    }

    private void verMotivocancelacionEquivalencia(MotivocancelacionEquivalencia ee) {
        if (ee == null) {
            return;
        }

        Map args = new HashMap();
        args.put("motivoCancelacionEquivalencia", ee);
        args.put("motivoCancelacionEquivalenciaList", motivoCancelacionEquivalenciaList);

        openWindow("/gui/equivalencia/editarMotivocancelacionEquivalencia.zul",
                Labels.getLabel("editarMotivoCancelacionEquivalenciaController.window.title"),
                args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<MotivocancelacionEquivalencia> motivoCancelacion =
                new HibernateSearchObject<MotivocancelacionEquivalencia>(MotivocancelacionEquivalencia.class, pagingMotivocancelacionEquivalencia.getPageSize());


        Comboitem ce = cmbComissionestaExterno.getSelectedItem();
        Comboitem mc = cmbMotivoCancelacion.getSelectedItem();

        if (ce != null) {
            ComisionistaExterno comissionistaExterno = (ComisionistaExterno) ce.getValue();
            motivoCancelacion.addFilterEqual("comisionistaExterno", comissionistaExterno);
        }
        if (mc != null) {
            MotivoCancelacion motCanc = (MotivoCancelacion) mc.getValue();
            motivoCancelacion.addFilterEqual("motivoCancelacion", motCanc);
        }
        if (!txtEquivalencia.getValue().equals("")) {
            motivoCancelacion.addFilterILike("equivalenciaId", txtEquivalencia.getValue());
        }
        motivoCancelacion.addFilterEqual("activo", Boolean.TRUE);

        motivoCancelacion.addSortAsc("motivoCancelacion.descmotivo");

        plwMotivocancelacionEquivalencia.init(motivoCancelacion, motivoCancelacionEquivalenciaList, pagingMotivocancelacionEquivalencia);

        if (motivoCancelacionEquivalenciaList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedamotivocancelacionEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }
}
